diff --git a/tests/imfile-readmode2.sh b/tests/imfile-readmode2.sh
index ff860ecbe..c0e074a9c 100755
--- a/tests/imfile-readmode2.sh
+++ b/tests/imfile-readmode2.sh
@@ -1,10 +1,30 @@
 #!/bin/bash
 # This is part of the rsyslog testbench, licensed under ASL 2.0
-echo ======================================================================
-echo [imfile-readmode2.sh]
-. $srcdir/diag.sh check-inotify
+#export RSYSLOG_DEBUG="debug nologfuncflow noprintmutexaction stdout"
+#export RSYSLOG_DEBUGLOG="log"
+
 . $srcdir/diag.sh init
-. $srcdir/diag.sh startup imfile-readmode2.conf
+. $srcdir/diag.sh check-inotify
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+global( debug.whitelist="on"
+	debug.files=["imfile.c"])
+
+module(load="../plugins/imfile/.libs/imfile")
+
+input(type="imfile" File="./rsyslog.input" Tag="file:" ReadMode="2")
+#input(type="imfile" File="./rsyslog.input.*" Tag="file:" ReadMode="2")
+
+template(name="outfmt" type="list") {
+  constant(value="HEADER ")
+  property(name="msg" format="json")
+  constant(value="\n")
+}
+
+if $msg contains "msgnum:" then
+	action(type="omfile" file="rsyslog.out.log" template="outfmt"
+ ) '
+. $srcdir/diag.sh startup
 
 # write the beginning of the file
 echo 'msgnum:0
@@ -20,22 +40,23 @@ echo 'msgnum:3
 echo 'msgnum:5' >> rsyslog.input # this one shouldn't be written to the output file because of ReadMode 2
 
 # give it time to finish
-sleep 1
+#echo you are in bash! ctl-d to exit
+#bash
 
 . $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
 . $srcdir/diag.sh wait-shutdown    # we need to wait until rsyslogd is finished!
 
 # give it time to write the output file
+
 sleep 1
+#cat log
 
 ## check if we have the correct number of messages
 
 NUMLINES=$(grep -c HEADER ./rsyslog.out.log 2>/dev/null)
 
 if [ -z $NUMLINES ]; then
-  echo "ERROR: expecting at least a match for HEADER, maybe rsyslog.out.log wasn't even written?"
-  cat ./rsyslog.out.log
-  exit 1
+  echo "ERROR: expecting at least a match for HEADER, maybe rsyslog.out.log wasn't even written?" cat ./rsyslog.out.log exit 1
 else
   if [ ! $NUMLINES -eq 3 ]; then
     echo "ERROR: expecting 3 headers, got $NUMLINES"
diff --git a/tests/imfile-rename-while-stopped.sh b/tests/imfile-rename-while-stopped.sh
new file mode 100755
index 000000000..79b1b455e
--- /dev/null
+++ b/tests/imfile-rename-while-stopped.sh
@@ -0,0 +1,33 @@
+#!/bin/bash
+# This is part of the rsyslog testbench, licensed under GPLv3
+export TESTMESSAGES=10000
+export RETRIES=10
+export TESTMESSAGESFULL=19999
+echo [imfile-rename.sh]
+. $srcdir/diag.sh check-inotify-only
+. $srcdir/diag.sh init
+
+# generate input file first. 
+./inputfilegen -m $TESTMESSAGES > rsyslog.input.1.log
+ls -li rsyslog.input*
+
+. $srcdir/diag.sh startup imfile-wildcards-simple.conf
+. $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
+. $srcdir/diag.sh wait-shutdown	# we need to wait until rsyslogd is finished!
+
+# Move to another filename
+mv rsyslog.input.1.log rsyslog.input.2.log
+
+# generate some more input into moved file 
+./inputfilegen -m $TESTMESSAGES -i $TESTMESSAGES >> rsyslog.input.2.log
+ls -li rsyslog.input*
+echo ls test-spool:
+ls -l test-spool
+
+. $srcdir/diag.sh startup imfile-wildcards-simple.conf
+. $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
+. $srcdir/diag.sh wait-shutdown	# we need to wait until rsyslogd is finished!
+
+. $srcdir/diag.sh seq-check 0 $TESTMESSAGESFULL
+wc rsyslog.out.log
+. $srcdir/diag.sh exit
diff --git a/tests/imfile-rename.sh b/tests/imfile-rename.sh
index 8646f5580..7a720169a 100755
--- a/tests/imfile-rename.sh
+++ b/tests/imfile-rename.sh
@@ -1,6 +1,7 @@
 #!/bin/bash
 # This is part of the rsyslog testbench, licensed under GPLv3
 export TESTMESSAGES=10000
+export RETRIES=10
 export TESTMESSAGESFULL=19999
 echo [imfile-rename.sh]
 . $srcdir/diag.sh check-inotify-only
@@ -13,17 +14,22 @@ ls -l rsyslog.input*
 . $srcdir/diag.sh startup imfile-wildcards-simple.conf
 
 # sleep a little to give rsyslog a chance to begin processing
-sleep 5
+
+. $srcdir/diag.sh wait-file-lines rsyslog.out.log $TESTMESSAGES $RETRIES
 
 # Move to another filename
 mv rsyslog.input.1.log rsyslog.input.2.log
 
+./msleep 500
 # generate some more input into moved file 
 ./inputfilegen -m $TESTMESSAGES -i $TESTMESSAGES >> rsyslog.input.2.log
 ls -l rsyslog.input*
+echo ls test-spool:
+ls -l test-spool
+./msleep 500
 
-# sleep a little to give rsyslog a chance to begin processing
-sleep 5
+let msgcount="2* $TESTMESSAGES"
+. $srcdir/diag.sh wait-file-lines rsyslog.out.log $msgcount $RETRIES
 
 . $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
 . $srcdir/diag.sh wait-shutdown	# we need to wait until rsyslogd is finished!
diff --git a/tests/imfile-truncate-line.sh b/tests/imfile-truncate-line.sh
index 5c17f3226..72587c659 100755
--- a/tests/imfile-truncate-line.sh
+++ b/tests/imfile-truncate-line.sh
@@ -56,7 +56,7 @@ HEADER msgnum:2 aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa\\\\n msgnum:3 bbbbb
 HEADER ccccccccccccccccccccccccccccccccccccc\\\\n msgnum:5 dddddddddddddddddddddddddddddddddddddddddddd
 HEADER msgnum:6 eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee\\\\n msgnum:7 ffffffffffffffffffffffffffffffffffffffffffff\\\\n msgnum:8 ggggggg
 HEADER ggggggggggggggggggggggggggggggggggggg
-HEADER msgnum:9\n' | cmp -b - rsyslog.out.log
+HEADER msgnum:9\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid multiline message generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/imfile-wildcards-dirs-multi.sh b/tests/imfile-wildcards-dirs-multi.sh
index f5295beee..ea10ba780 100755
--- a/tests/imfile-wildcards-dirs-multi.sh
+++ b/tests/imfile-wildcards-dirs-multi.sh
@@ -3,7 +3,7 @@
 export IMFILEINPUTFILES="10"
 export IMFILEINPUTFILESSTEPS="5"
 #export IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $IMFILEINPUTFILESSTEPS))
-export IMFILECHECKTIMEOUT="5"
+export IMFILECHECKTIMEOUT="20"
 . $srcdir/diag.sh init
 . $srcdir/diag.sh check-inotify-only
 # generate input files first. Note that rsyslog processes it as
diff --git a/tests/imfile-wildcards-dirs-multi2.sh b/tests/imfile-wildcards-dirs-multi2.sh
index 59d844097..01413e559 100755
--- a/tests/imfile-wildcards-dirs-multi2.sh
+++ b/tests/imfile-wildcards-dirs-multi2.sh
@@ -3,9 +3,8 @@
 export IMFILEINPUTFILES="1"
 export IMFILEINPUTFILESSTEPS="5"
 #export IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $IMFILEINPUTFILESSTEPS))
-export IMFILECHECKTIMEOUT="5"
+export IMFILECHECKTIMEOUT="20"
 . $srcdir/diag.sh init
-. $srcdir/diag.sh check-inotify-only
 # generate input files first. Note that rsyslog processes it as
 # soon as it start up (so the file should exist at that point).
 
diff --git a/tests/imfile-wildcards-dirs-multi3.sh b/tests/imfile-wildcards-dirs-multi3.sh
index 23c2139bd..0fecffa81 100755
--- a/tests/imfile-wildcards-dirs-multi3.sh
+++ b/tests/imfile-wildcards-dirs-multi3.sh
@@ -3,9 +3,8 @@
 export IMFILEINPUTFILES="1"
 export IMFILEINPUTFILESSTEPS="5"
 #export IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $IMFILEINPUTFILESSTEPS))
-export IMFILECHECKTIMEOUT="5"
+export IMFILECHECKTIMEOUT="10"
 . $srcdir/diag.sh init
-. $srcdir/diag.sh check-inotify-only
 # generate input files first. Note that rsyslog processes it as
 # soon as it start up (so the file should exist at that point).
 
@@ -13,6 +12,7 @@ for i in `seq 1 $IMFILEINPUTFILES`;
 do
 	echo "Make rsyslog.input.dir$i"
 	mkdir rsyslog.input.dir$i
+		echo created!
 done
 
 # Start rsyslog now before adding more files
@@ -30,6 +30,7 @@ do
 		mkdir rsyslog.input.dir$i/dir$j/testdir
 		mkdir rsyslog.input.dir$i/dir$j/testdir/subdir$j
 		./inputfilegen -m 1 > rsyslog.input.dir$i/dir$j/testdir/subdir$j/file.logfile
+		ls -l rsyslog.input.dir$i/dir$j/testdir/subdir$j/file.logfile
 	done
 	ls -d rsyslog.input.*
 
diff --git a/tests/imfile-wildcards-dirs-multi4.sh b/tests/imfile-wildcards-dirs-multi4.sh
index a8121a71b..454ae7c4d 100755
--- a/tests/imfile-wildcards-dirs-multi4.sh
+++ b/tests/imfile-wildcards-dirs-multi4.sh
@@ -3,9 +3,9 @@
 export IMFILEINPUTFILES="1"
 export IMFILEINPUTFILESSTEPS="5"
 #export IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $IMFILEINPUTFILESSTEPS))
-export IMFILECHECKTIMEOUT="5"
+export IMFILECHECKTIMEOUT="20"
 . $srcdir/diag.sh init
-. $srcdir/diag.sh check-inotify-only
+. $srcdir/diag.sh check-inotify
 # generate input files first. Note that rsyslog processes it as
 # soon as it start up (so the file should exist at that point).
 
diff --git a/tests/imfile-wildcards-dirs-multi5-polling.sh b/tests/imfile-wildcards-dirs-multi5-polling.sh
new file mode 100755
index 000000000..0689bd087
--- /dev/null
+++ b/tests/imfile-wildcards-dirs-multi5-polling.sh
@@ -0,0 +1,77 @@
+#!/bin/bash
+# This is part of the rsyslog testbench, licensed under GPLv3
+export IMFILEINPUTFILES="8" #"8"
+export IMFILEINPUTFILESSTEPS="5" #"5"
+#export IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $IMFILEINPUTFILESSTEPS))
+export IMFILECHECKTIMEOUT="5"
+. $srcdir/diag.sh init
+#. $srcdir/diag.sh check-inotify-only
+# generate input files first. Note that rsyslog processes it as
+# soon as it start up (so the file should exist at that point).
+
+# Start rsyslog now before adding more files
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+global( debug.whitelist="on"
+	debug.files=["imfile.c"])
+#	debug.files=["rainerscript.c", "ratelimit.c", "ruleset.c", "main Q",
+#	"msg.c", "../action.c", "imdiag.c"])
+
+module(load="../plugins/imfile/.libs/imfile" mode="polling" pollingInterval="1")
+
+input(type="imfile" File="./rsyslog.input.dir?/*/*.logfile"
+	Tag="file:" Severity="error" Facility="local7" addMetadata="on")
+input(type="imfile" File="./rsyslog.input.alt/alt*file"
+	Tag="file:" Severity="error" Facility="local7" addMetadata="on")
+
+template(name="outfmt" type="list") {
+  constant(value="HEADER ")
+  property(name="msg" format="json")
+  constant(value=", ")
+  property(name="$!metadata!filename")
+  constant(value="\n")
+}
+
+if $msg contains "msgnum:" then
+	action( type="omfile" file="rsyslog.out.log" template="outfmt")
+'
+
+# create first directory and file before startup, so ensure we will NOT
+# get an initial inotify notify for it!
+#mkdir rsyslog.input.alt
+#./inputfilegen -m 1 > rsyslog.input.alt/altfile.logfile
+#mkdir rsyslog.input.dir1
+# the following is INVALID, as this is a file, but must be a directory!
+#./inputfilegen -m 1 > rsyslog.input.dir0
+
+. $srcdir/diag.sh startup 
+
+for j in `seq 1 $IMFILEINPUTFILESSTEPS`;
+do
+	echo "Loop Num $j"
+
+	for i in `seq 1 $IMFILEINPUTFILES`;
+	do
+		mkdir rsyslog.input.dir$i
+		mkdir rsyslog.input.dir$i/dir$i
+		./inputfilegen -m 1 > rsyslog.input.dir$i/dir$i/file.logfile
+	done
+
+	ls -d rsyslog.input.*
+	
+	# Check correct amount of input files each time
+	let IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $j))
+	. $srcdir/diag.sh content-check-with-count "HEADER msgnum:00000000:" $IMFILEINPUTFILESALL $IMFILECHECKTIMEOUT
+
+	# Delete all but first!
+	for i in `seq 1 $IMFILEINPUTFILES`;
+	do
+		rm -rf rsyslog.input.dir$i/dir$i/file.logfile
+		rm -rf rsyslog.input.dir$i
+	done
+
+done
+
+. $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
+. $srcdir/diag.sh wait-shutdown	# we need to wait until rsyslogd is finished!
+. $srcdir/diag.sh exit
diff --git a/tests/imfile-wildcards-dirs-multi5.sh b/tests/imfile-wildcards-dirs-multi5.sh
new file mode 100755
index 000000000..501db4338
--- /dev/null
+++ b/tests/imfile-wildcards-dirs-multi5.sh
@@ -0,0 +1,82 @@
+#!/bin/bash
+# This is part of the rsyslog testbench, licensed under GPLv3
+export IMFILEINPUTFILES="8" #"8"
+export IMFILEINPUTFILESSTEPS="5" #"5"
+#export IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $IMFILEINPUTFILESSTEPS))
+export IMFILECHECKTIMEOUT="20"
+. $srcdir/diag.sh init
+# generate input files first. Note that rsyslog processes it as
+# soon as it start up (so the file should exist at that point).
+
+# Start rsyslog now before adding more files
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+global( debug.whitelist="on"
+	debug.files=["imfile.c"])
+
+module(load="../plugins/imfile/.libs/imfile" mode="inotify" pollingInterval="1")
+
+input(type="imfile" File="./rsyslog.input.dir?/*/*.logfile"
+	Tag="file:" Severity="error" Facility="local7" addMetadata="on")
+input(type="imfile" File="./rsyslog.input.alt/alt*file"
+	Tag="file:" Severity="error" Facility="local7" addMetadata="on")
+
+template(name="outfmt" type="list") {
+  constant(value="HEADER ")
+  property(name="msg" format="json")
+  constant(value="'"'"', ")
+  property(name="$!metadata!filename")
+  constant(value="\n")
+}
+
+if $msg contains "msgnum:" then
+	action( type="omfile" file="rsyslog.out.log" template="outfmt")
+
+#*.* action(type="omfile" file="rsyslog.debug")
+'
+
+# create first directory and file before startup, so ensure we will NOT
+# get an initial inotify notify for it!
+mkdir rsyslog.input.alt
+#./inputfilegen -m 1 > rsyslog.input.alt/altfile.logfile
+mkdir rsyslog.input.dir1
+# the following is INVALID, as this is a file, but must be a directory!
+./inputfilegen -m 1 > rsyslog.input.dir0
+
+. $srcdir/diag.sh startup 
+
+for j in `seq 1 $IMFILEINPUTFILESSTEPS`;
+do
+	echo "Loop Num $j"
+
+	for i in `seq 1 $IMFILEINPUTFILES`;
+	do
+		mkdir rsyslog.input.dir$i
+		mkdir rsyslog.input.dir$i/dir$i
+		./inputfilegen -m 1 > rsyslog.input.dir$i/dir$i/file.logfile
+	done
+
+	ls -d rsyslog.input.*
+	
+	# Check correct amount of input files each time
+	let IMFILEINPUTFILESALL=$(($IMFILEINPUTFILES * $j))
+	. $srcdir/diag.sh content-check-with-count "HEADER msgnum:00000000:" $IMFILEINPUTFILESALL $IMFILECHECKTIMEOUT
+
+	# Delete all but first!
+	for i in `seq 1 $IMFILEINPUTFILES`;
+	do
+		# slow systems (NFS) do not reliably do rm -r (unfortunately...)
+		rm -rf rsyslog.input.dir$i/dir$i/file.logfile
+		./msleep 100
+		rm -rf rsyslog.input.dir$i/dir$i
+		./msleep 100
+		rm -vrf rsyslog.input.dir$i
+	done
+
+done
+
+. $srcdir/diag.sh shutdown-when-empty # shut down rsyslogd when done processing messages
+. $srcdir/diag.sh wait-shutdown	# we need to wait until rsyslogd is finished!
+#echo rsyslog.debug:
+#cat rsyslog.debug
+. $srcdir/diag.sh exit
diff --git a/tests/imfile-wildcards-dirs.sh b/tests/imfile-wildcards-dirs.sh
index e86d34c9f..d1cea30c6 100755
--- a/tests/imfile-wildcards-dirs.sh
+++ b/tests/imfile-wildcards-dirs.sh
@@ -2,7 +2,7 @@
 # This is part of the rsyslog testbench, licensed under GPLv3
 export IMFILEINPUTFILES="10"
 echo [imfile-wildcards-dirs.sh]
-. $srcdir/diag.sh check-inotify-only
+. $srcdir/diag.sh check-inotify
 . $srcdir/diag.sh init
 # generate input files first. Note that rsyslog processes it as
 # soon as it start up (so the file should exist at that point).
diff --git a/tests/imfile-wildcards.sh b/tests/imfile-wildcards.sh
index 9eb3602f3..fd81583fc 100755
--- a/tests/imfile-wildcards.sh
+++ b/tests/imfile-wildcards.sh
@@ -10,8 +10,36 @@ echo [imfile-wildcards.sh]
 imfilebefore="rsyslog.input.1.log"
 ./inputfilegen -m 1 > $imfilebefore
 
+. $srcdir/diag.sh generate-conf
+. $srcdir/diag.sh add-conf '
+# comment out if you need more debug info:
+	global( debug.whitelist="on"
+		debug.files=["imfile.c"])
+
+module(load="../plugins/imfile/.libs/imfile"
+       mode="inotify" normalizePath="off")
+
+input(type="imfile" File="./rsyslog.input.*.log" Tag="file:"
+	Severity="error" Facility="local7" addMetadata="on")
+
+input(type="imfile" File="/does/not/exist/*.log" Tag="file:"
+	Severity="error" Facility="local7" addMetadata="on")
+
+template(name="outfmt" type="list") {
+	constant(value="HEADER ")
+	property(name="msg" format="json")
+	constant(value=", filename: ")
+	property(name="$!metadata!filename")
+	constant(value=", fileoffset: ")
+	property(name="$!metadata!fileoffset")
+	constant(value="\n")
+}
+
+if $msg contains "msgnum:" then
+	action( type="omfile" file="rsyslog.out.log" template="outfmt")
+'
 # Start rsyslog now before adding more files
-. $srcdir/diag.sh startup imfile-wildcards.conf
+. $srcdir/diag.sh startup
 
 for i in `seq 2 $IMFILEINPUTFILES`;
 do
@@ -38,7 +66,7 @@ HEADER msgnum:00000000:, filename: ./rsyslog.input.9.log, fileoffset: 0
 HEADER msgnum:00000000:, filename: ./rsyslog.input.10.log, fileoffset: 0
 HEADER msgnum:00000000:, filename: ./rsyslog.input.11.log, fileoffset: 0
 HEADER msgnum:00000001:, filename: ./rsyslog.input.11.log, fileoffset: 17
-HEADER msgnum:00000002:, filename: ./rsyslog.input.11.log, fileoffset: 34\n' | cmp -b rsyslog.out.log
+HEADER msgnum:00000002:, filename: ./rsyslog.input.11.log, fileoffset: 34\n' | cmp - rsyslog.out.log
 if [ ! $? -eq 0 ]; then
   echo "invalid output generated, rsyslog.out.log is:"
   cat rsyslog.out.log
diff --git a/tests/testsuites/imfile-wildcards-dirs-multi.conf b/tests/testsuites/imfile-wildcards-dirs-multi.conf
index 5be403a43..ff93a901c 100644
--- a/tests/testsuites/imfile-wildcards-dirs-multi.conf
+++ b/tests/testsuites/imfile-wildcards-dirs-multi.conf
@@ -2,10 +2,12 @@ $IncludeConfig diag-common.conf
 $WorkDirectory test-spool
 
 /* Filter out busy debug output, comment out if needed */
+/*
 global(
 	debug.whitelist="off"
 	debug.files=["rainerscript.c", "ratelimit.c", "ruleset.c", "main Q", "msg.c", "../action.c"]
 )
+*/
 
 module(	load="../plugins/imfile/.libs/imfile" 
 	mode="inotify" 
